diff -ruN ../nakedmudv2.4/src/Makefile src/Makefile
--- ../nakedmudv2.4/src/Makefile	Sat Jun  4 23:44:07 2005
+++ src/Makefile	Sat Jun 18 15:03:27 2005
@@ -108,7 +108,16 @@
 # include all of our dependencies
 include $(patsubst %.c,%.d, $(SRC))
 
-# calculate all of our dependencies
+# calculate all of our dependencies. It's messy, but it works
 %.d: %.c
 	@echo "Building dependencies for $(patsubst %.d,%.c, $@)"
-	@./depend.sh $(patsubst %.d,%.c, $@) > $@
+	@case $(shell dirname $@) in					 \
+	"" | ".") 							 \
+	  gcc $(C_FLAGS) -MM $(patsubst %.d,%.c, $@) | 			 \
+	    sed -e 's@^\(.*\)\.o:@\1.d \1.o:@' > $@			 \
+	;; 								 \
+	*) 								 \
+	  gcc $(C_FLAGS) -MM $(patsubst %.d,%.c, $@) | 			 \
+	    sed -e "s@^\(.*\)\.o:@$(shell dirname $@)/\1.d $(shell dirname $@)/\1.o:@" > $@ 					 			 \
+        ;;                                                               \
+	esac
diff -ruN ../nakedmudv2.4/src/action.c src/action.c
--- ../nakedmudv2.4/src/action.c	Sat Jun  4 23:40:30 2005
+++ src/action.c	Sat Jun 18 14:46:43 2005
@@ -65,8 +65,12 @@
 }
 
 COMMAND(cmd_dsay) {
-  send_to_char(ch, "You start a delayed say.\r\n");
-  start_action(ch, 3 SECOND, 1, do_dsay, dsay_interrupt, NULL, arg);
+  if(!*arg)
+    send_to_char(ch, "What did you want to delay-say?\r\n");
+  else {
+    send_to_char(ch, "You start a delayed say.\r\n");
+    start_action(ch, 3 SECOND, 1, do_dsay, dsay_interrupt, NULL, arg);
+  }
 }
 
 
diff -ruN ../nakedmudv2.4/src/auxiliary.c src/auxiliary.c
--- ../nakedmudv2.4/src/auxiliary.c	Sat Jun  4 23:40:30 2005
+++ src/auxiliary.c	Sat Jun 18 14:46:43 2005
@@ -29,6 +29,17 @@
 // auxiliary functions on our datatypes
 HASHTABLE *auxiliary_manip_funcs = NULL;
 
+struct auxiliary_functions {
+  bitvector_t aux_type;
+  bool           is_py;
+  void          *(* new)(void);
+  void        (* delete)(void *data);
+  void        (* copyTo)(void *from, void *to);
+  void        *(*  copy)(void *data);
+  STORAGE_SET *(* store)(void *data);
+  void        *(*  read)(STORAGE_SET *set);
+};
+
 
 
 //*****************************************************************************
@@ -46,6 +57,7 @@
 newAuxiliaryFuncs(bitvector_t aux_type, void *new, void *delete, 
 		  void *copyTo, void *copy, void *store, void *read) {
   AUXILIARY_FUNCS *newfuncs = malloc(sizeof(AUXILIARY_FUNCS));
+  newfuncs->is_py    = FALSE;
   newfuncs->aux_type = aux_type;
   newfuncs->new      = new;
   newfuncs->delete   = delete;
@@ -61,6 +73,9 @@
   free(funcs);
 }
 
+void auxiliaryFuncSetIsPy(AUXILIARY_FUNCS *funcs, bool val) {
+  funcs->is_py = val;
+}
 
 void
 auxiliariesInstall(const char *name, AUXILIARY_FUNCS *funcs) {
@@ -90,8 +105,16 @@
   const char       *name = NULL;
 
   ITERATE_HASH(name, funcs, hash_i) {
-    if(IS_SET(funcs->aux_type, aux_type))
-      hashPut(data, name, funcs->new());
+    if(IS_SET(funcs->aux_type, aux_type)) {
+      // are we dealing with python data or not?
+      if(!funcs->is_py) 
+	hashPut(data, name, funcs->new());
+      else {
+	// recast the new function
+	void *(* new)(const char *) = (void *)funcs->new;
+	hashPut(data, name, new(name));
+      }
+    }
   } deleteHashIterator(hash_i);
   return data;
 }
@@ -104,8 +127,16 @@
   const char       *name = NULL;
 
   ITERATE_HASH(name, funcs, hash_i) {
-    if(IS_SET(funcs->aux_type, aux_type) && !hashGet(data, name))
-      hashPut(data, name, funcs->new());
+    if(IS_SET(funcs->aux_type, aux_type) && !hashGet(data, name)) {
+      // are we dealing with python data or not?
+      if(!funcs->is_py) 
+	hashPut(data, name, funcs->new());
+      else {
+	// recast the new function
+	void *(* new)(const char *) = (void *)funcs->new;
+	hashPut(data, name, new(name));
+      }
+    }
   } deleteHashIterator(hash_i);
 }
 
@@ -153,10 +184,22 @@
   ITERATE_HASH(name, funcs, hash_i) {
     if(!IS_SET(funcs->aux_type, aux_type))
       continue;
-    if(funcs->read)
+    // are we dealing with python data or not?
+    if(!funcs->is_py && funcs->read)
       hashPut(data, name, funcs->read(read_set(set, name)));
-    else
+    else if(funcs->read) {
+      // recast the read function
+      void *(* read)(const char *, STORAGE_SET *) = (void *)funcs->read;
+      hashPut(data, name, read(name, read_set(set, name)));
+    }
+    // are we dealing with python data or not?
+    else if(!funcs->is_py) 
       hashPut(data, name, funcs->new());
+    else {
+      // recast the new function
+      void *(* new)(const char *) = (void *)funcs->new;
+      hashPut(data, name, new(name));
+    }
   } deleteHashIterator(hash_i);
   return data;
 }
diff -ruN ../nakedmudv2.4/src/auxiliary.h src/auxiliary.h
--- ../nakedmudv2.4/src/auxiliary.h	Sat Jun  4 23:40:29 2005
+++ src/auxiliary.h	Sat Jun 18 14:46:43 2005
@@ -25,7 +25,7 @@
 
 //
 // A structure containing 6 functions that are needed for storing and saving
-// auxiliary data that is used by auxiliarys outside the core of the MUD.
+// auxiliary data that is used by auxiliaries outside the core of the MUD.
 //
 // aux_type is a list of the types of datastructures this auxiliary data is
 // intended for.
@@ -48,16 +48,7 @@
 //
 // read should be a function that takes a storage set, and parses auxiliary
 // data from that.
-//
-typedef struct auxiliary_functions {
-  bitvector_t aux_type;
-  void          *(* new)();
-  void        (* delete)(void *data);
-  void        (* copyTo)(void *from, void *to);
-  void        *(*  copy)(void *data);
-  STORAGE_SET *(* store)(void *data);
-  void        *(*  read)(STORAGE_SET *set);
-} AUXILIARY_FUNCS;
+typedef struct auxiliary_functions AUXILIARY_FUNCS;
 
 
 //
@@ -72,6 +63,22 @@
 AUXILIARY_FUNCS *
 newAuxiliaryFuncs(bitvector_t aux_type, void *new, void *delete, 
 		  void *copyTo, void *copy, void *store, void *read);
+
+
+//
+// Creating auxiliary data in python is poses a problem. Ideally, we would like
+// to be able to arbitrarily add new data to chars/objs/rooms/etc... in Python
+// without touching any C aspects of the code. But then, how do we create new()
+// and read() functions (the others are trivial) for creating the auxiliary
+// data? The simple answer is that we can't, really. We have to do a little bit
+// of a work-around and allow Python auxiliary data new() and read() functions
+// to be looked up in a table when they are added via the python modules. Python
+// auxiliary data can set this special flag on auxiliary functions. If the flag
+// is set, the key for the auxiliary data will also be passed along to the new()
+// and read() functions so the proper python methods can be looked up and 
+// called. NO NORMAL auxiliary data should even touch this! This is for Python
+// use only.
+void auxiliaryFuncSetIsPy(AUXILIARY_FUNCS *funcs, bool val);
 
 
 //
diff -ruN ../nakedmudv2.4/src/bitvector.h src/bitvector.h
--- ../nakedmudv2.4/src/bitvector.h	Sat Jun  4 23:40:29 2005
+++ src/bitvector.h	Sat Jun 18 14:46:43 2005
@@ -108,7 +108,7 @@
 //
 // return a list of the possible bits that this vector can have set. The list
 // must be deleted after use, as well as all the contents. 
-// try: listDeleteWith(list, free)
+// try: deleteListWith(list, free)
 LIST *bitvectorListBits(BITVECTOR *v);
 
 #endif // BITVECTOR_H
diff -ruN ../nakedmudv2.4/src/buffer.c src/buffer.c
--- ../nakedmudv2.4/src/buffer.c	Sat Jun  4 23:40:29 2005
+++ src/buffer.c	Sat Jun 18 14:46:43 2005
@@ -211,7 +211,7 @@
 void bufferFormat(BUFFER *buf, int max_width, int indent) {
   char formatted[(buf->len * 3)/2];
   bool needs_capital = TRUE, needs_indent = FALSE;
-  int fmt_i = 0, buf_i = 0, col = 0;
+  int fmt_i = 0, buf_i = 0, col = 0, next_space = 0;
 
   // put in our indent
   if(indent > 0) {
@@ -229,7 +229,10 @@
 
   for(; buf->data[buf_i] != '\0'; buf_i++) {
     // we have to put a newline in because the word won't fit on the line
-    if(col + next_space_in(buf->data+buf_i) > max_width-2) {
+    next_space = next_space_in(buf->data + buf_i);
+    if(next_space == -1)
+      next_space = buf->len - buf_i;
+    if(col + next_space > max_width-2) {
       formatted[fmt_i] = '\r'; fmt_i++;
       formatted[fmt_i] = '\n'; fmt_i++;
       col = 0;
@@ -268,7 +271,10 @@
       // check if indenting will make it so we don't
       // have enough room to print the word. If that's the
       // case, then skip down to a new line instead
-      if(col + 2 + next_space_in(buf->data+buf_i) > max_width-2) {
+      next_space = next_space_in(buf->data + buf_i);
+      if(next_space == -1)
+	next_space = buf->len - buf_i;
+      if(col + 2 + next_space > max_width-2) {
 	formatted[fmt_i] = '\r'; fmt_i++;
 	formatted[fmt_i] = '\n'; fmt_i++;
 	col = 0;
diff -ruN ../nakedmudv2.4/src/character.c src/character.c
--- ../nakedmudv2.4/src/character.c	Sat Jun  4 23:40:29 2005
+++ src/character.c	Sat Jun 18 14:46:43 2005
@@ -90,7 +90,7 @@
 
 struct char_data {
   // data for PCs only
-  room_vnum              loadroom;
+  int              loadroom;
 
   // shared data for PCs and NPCs
   int                    uid;
@@ -112,12 +112,12 @@
   BITVECTOR            * user_groups;
 
   // data for NPCs only
-  dialog_vnum            dialog;
+  int            dialog;
   char                 * rdesc;
   char                 * multi_name;
   char                 * multi_rdesc;
   char                 * keywords;
-  mob_vnum               vnum;  
+  int               vnum;  
 };
 
 
@@ -249,7 +249,7 @@
   return ch->uid;
 }
 
-room_vnum    charGetLoadroom (CHAR_DATA *ch) {
+int    charGetLoadroom (CHAR_DATA *ch) {
   return ch->loadroom;
 }
 
@@ -316,7 +316,7 @@
   charSetBody(ch, raceCreateBody(ch->race));
 }
 
-void charSetLoadroom(CHAR_DATA *ch, room_vnum loadroom) {
+void charSetLoadroom(CHAR_DATA *ch, int loadroom) {
   ch->loadroom = loadroom;
 }
 
@@ -472,19 +472,19 @@
   ch->keywords = strdup(keywords ? keywords : "");
 }
 
-void charSetVnum(CHAR_DATA *ch, mob_vnum vnum) {
+void charSetVnum(CHAR_DATA *ch, int vnum) {
   ch->vnum = vnum;
 }
 
-void charSetDialog(CHAR_DATA *ch, dialog_vnum vnum) {
+void charSetDialog(CHAR_DATA *ch, int vnum) {
   ch->dialog = vnum;
 }
 
-mob_vnum     charGetVnum       ( CHAR_DATA *ch) {
+int     charGetVnum       ( CHAR_DATA *ch) {
   return ch->vnum;
 }
 
-dialog_vnum  charGetDialog     ( CHAR_DATA *ch) {
+int  charGetDialog     ( CHAR_DATA *ch) {
   return ch->dialog;
 }
 
diff -ruN ../nakedmudv2.4/src/character.h src/character.h
--- ../nakedmudv2.4/src/character.h	Sat Jun  4 23:40:29 2005
+++ src/character.h	Sat Jun 18 14:46:43 2005
@@ -84,7 +84,7 @@
 LIST        *charGetInventory ( CHAR_DATA *ch);
 BODY_DATA   *charGetBody      ( CHAR_DATA *ch);
 const char  *charGetRace      ( CHAR_DATA *ch);
-room_vnum    charGetLoadroom  ( CHAR_DATA *ch);
+int    charGetLoadroom  ( CHAR_DATA *ch);
 OBJ_DATA    *charGetFurniture ( CHAR_DATA *ch);
 int          charGetPos       ( CHAR_DATA *ch);
 int          charGetUID       ( const CHAR_DATA *ch);
@@ -104,7 +104,7 @@
 void         charSetBody      ( CHAR_DATA *ch, BODY_DATA *body);
 void         charSetRace      ( CHAR_DATA *ch, const char *race);
 void         charSetUID       ( CHAR_DATA *ch, int uid);
-void         charSetLoadroom  ( CHAR_DATA *ch, room_vnum loadroom);
+void         charSetLoadroom  ( CHAR_DATA *ch, int loadroom);
 void         charSetFurniture ( CHAR_DATA *ch, OBJ_DATA *furniture);
 void         charSetPos       ( CHAR_DATA *ch, int pos);
 
@@ -113,12 +113,12 @@
 //*****************************************************************************
 // mob-specific functions
 //*****************************************************************************
-mob_vnum     charGetVnum       (CHAR_DATA *ch);
-dialog_vnum  charGetDialog     (CHAR_DATA *ch);
+int     charGetVnum       (CHAR_DATA *ch);
+int  charGetDialog     (CHAR_DATA *ch);
 const char  *charGetKeywords   (CHAR_DATA *ch);
 
-void         charSetVnum       (CHAR_DATA *ch, mob_vnum vnum);
-void         charSetDialog     (CHAR_DATA *ch, dialog_vnum vnum);
+void         charSetVnum       (CHAR_DATA *ch, int vnum);
+void         charSetDialog     (CHAR_DATA *ch, int vnum);
 void         charSetKeywords   (CHAR_DATA *ch, const char *keywords);
 
 
diff -ruN ../nakedmudv2.4/src/cmd_builder.c src/cmd_builder.c
--- ../nakedmudv2.4/src/cmd_builder.c	Sat Jun  4 23:40:29 2005
+++ src/cmd_builder.c	Sat Jun 18 14:46:43 2005
@@ -37,7 +37,7 @@
 // Try to dig a special exit in a specific direction. Unlike cmd_dig,
 // specdig does not link the room we're digging to, back to us, since
 // we can't really figure out what the opposite direction is
-void try_specdig(CHAR_DATA *ch, const char *dir, room_vnum to) {
+void try_specdig(CHAR_DATA *ch, const char *dir, int to) {
   if(roomGetExitSpecial(charGetRoom(ch), dir))
     send_to_char(ch, "You must fill in the %s exit before you dig a new exit.\r\n", dir);
   else if(!worldGetRoom(gameworld, to))
@@ -329,6 +329,82 @@
   bitToggle(charGetPrfs(ch), "buildwalk");
   send_to_char(ch, "Buildwalk %s.\r\n",
 	       (bitIsOneSet(charGetPrfs(ch), "buildwalk") ? "on":"off"));
+}
+
+
+//
+// attach a new script to the given instanced object/mobile/room
+COMMAND(cmd_attach) {
+  char vbuf[SMALL_BUFFER];
+  arg = one_arg(arg, vbuf);
+  int vnum = atoi(vbuf);
+
+  // check to make sure our vnum is OK
+  if(!isdigit(*vbuf) || vnum == 0)
+    send_to_char(ch, "Invalid script vnum!\r\n");
+  else if(!worldGetScript(gameworld, vnum))
+    send_to_char(ch, "No script exists with that vnum.\r\n");
+  // we're trying to edit the room, not a char or mobile
+  if(!strcasecmp(arg, "room")) {
+    scriptSetAdd(roomGetScripts(charGetRoom(ch)), vnum);
+    send_to_char(ch, "Script number %d attached to the room.\r\n", vnum);
+  }
+  else {
+    int tgt_type = FOUND_NONE;
+    void    *tgt = generic_find(ch, arg, FIND_TYPE_CHAR | FIND_TYPE_OBJ,
+				FIND_SCOPE_IMMEDIATE, FALSE, &tgt_type);
+
+    // make sure the target exists
+    if(tgt == NULL || tgt_type == FOUND_NONE)
+      send_to_char(ch, "Target not found.\r\n");
+    else if(tgt_type == FOUND_CHAR) {
+      send_to_char(ch, "Script number %d attached to %s.\r\n", vnum,
+		   charGetName(tgt));
+      scriptSetAdd(charGetScripts(tgt), vnum);
+    }
+    else {
+      send_to_char(ch, "Script number %d attached to %s.\r\n", vnum,
+		   objGetName(tgt));
+      scriptSetAdd(objGetScripts(tgt), vnum);
+    }
+  }  
+}
+
+
+//
+// attach a new script to the given instanced object/mobile/room
+COMMAND(cmd_detach) {
+  char vbuf[SMALL_BUFFER];
+  arg = one_arg(arg, vbuf);
+  int vnum = atoi(vbuf);
+
+  // check to make sure our vnum is OK
+  if(!isdigit(*vbuf) || vnum == 0)
+    send_to_char(ch, "Invalid script vnum!\r\n");
+  // we're trying to edit the room, not a char or mobile
+  if(!strcasecmp(arg, "room")) {
+    scriptSetRemove(roomGetScripts(charGetRoom(ch)), vnum);
+    send_to_char(ch, "Script number %d detached from the room.\r\n", vnum);
+  }
+  else {
+    int tgt_type = FOUND_NONE;
+    void    *tgt = generic_find(ch, arg, FIND_TYPE_CHAR | FIND_TYPE_OBJ,
+				FIND_SCOPE_IMMEDIATE, FALSE, &tgt_type);
+
+    // make sure the target exists
+    if(tgt == NULL || tgt_type == FOUND_NONE)
+      send_to_char(ch, "Target not found.\r\n");
+    else if(tgt_type == FOUND_CHAR) {
+      send_to_char(ch, "Script number %d detached to %s.\r\n", vnum,
+		   charGetName(tgt));
+      scriptSetRemove(charGetScripts(tgt), vnum);
+    }
+    else {
+      send_to_char(ch, "Script number %d detached to %s.\r\n", vnum,
+		   objGetName(tgt));
+      scriptSetRemove(objGetScripts(tgt), vnum);
+    }
+  }  
 }
 
 
diff -ruN ../nakedmudv2.4/src/commands.h src/commands.h
--- ../nakedmudv2.4/src/commands.h	Sat Jun  4 23:40:29 2005
+++ src/commands.h	Sat Jun 18 14:46:43 2005
@@ -37,6 +37,8 @@
 COMMAND(cmd_mdelete);
 COMMAND(cmd_odelete);
 COMMAND(cmd_ddelete);
+COMMAND(cmd_detach);
+COMMAND(cmd_attach);
 
 
 /* cmd_manip.c */
diff -ruN ../nakedmudv2.4/src/dialog.c src/dialog.c
--- ../nakedmudv2.4/src/dialog.c	Sat Jun  4 23:40:29 2005
+++ src/dialog.c	Sat Jun 18 14:46:43 2005
@@ -231,7 +231,7 @@
   return dialog->name;
 }
 
-dialog_vnum dialogGetVnum(DIALOG_DATA *dialog) {
+int dialogGetVnum(DIALOG_DATA *dialog) {
   return dialog->vnum;
 }
 
@@ -256,7 +256,7 @@
   bufferCat(dialog->greet, (greet ? greet : ""));
 }
 
-void dialogSetVnum(DIALOG_DATA *dialog, dialog_vnum vnum) {
+void dialogSetVnum(DIALOG_DATA *dialog, int vnum) {
   dialog->vnum = vnum;
 }
 
diff -ruN ../nakedmudv2.4/src/dialog.h src/dialog.h
--- ../nakedmudv2.4/src/dialog.h	Sat Jun  4 23:40:29 2005
+++ src/dialog.h	Sat Jun 18 14:46:43 2005
@@ -51,8 +51,8 @@
 const char    *dialogGetGreet    (DIALOG_DATA *dialog);
 void           dialogSetGreet    (DIALOG_DATA *dialog, const char *greet);
 
-void           dialogSetVnum     (DIALOG_DATA *dialog, dialog_vnum vnum);
-dialog_vnum    dialogGetVnum     (DIALOG_DATA *dialog);
+void           dialogSetVnum     (DIALOG_DATA *dialog, int vnum);
+int    dialogGetVnum     (DIALOG_DATA *dialog);
 
 void           dialogSetName     (DIALOG_DATA *dialog, const char *name);
 const char    *dialogGetName     (DIALOG_DATA *dialog);
diff -ruN ../nakedmudv2.4/src/event.c src/event.c
--- ../nakedmudv2.4/src/event.c	Sat Jun  4 23:40:29 2005
+++ src/event.c	Sat Jun 18 14:46:43 2005
@@ -42,28 +42,23 @@
 // a small test for delayed events ... proof of concept
 //
 //******************************************************************************
-struct devent_data {
-  CHAR_DATA *speaker;
-};
-
-void devent_on_complete(CHAR_DATA *owner, struct devent_data *data, char *arg) {
-  communicate(data->speaker, arg, COMM_GLOBAL);
-  free(data);
+void devent_on_complete(CHAR_DATA *owner, void *data, char *arg) {
+  communicate(owner, arg, COMM_GLOBAL);
 }
 
-bool check_devent_involvement(void *thing, struct devent_data *data) {
-  if(thing == data->speaker)
-    return TRUE;
-  return FALSE;
+bool check_devent_involvement(void *thing, void *data) {
+  return (thing == data);
 }
 
 COMMAND(cmd_devent) {
-  struct devent_data *data = malloc(sizeof(struct devent_data));
-  data->speaker = ch;
-  start_event(ch,
-	      5 SECONDS,
-	      devent_on_complete, check_devent_involvement, 
-	      data, arg);
+  if(!*arg)
+    send_to_char(ch, "What did you want to delay-chat?\r\n");
+  else {
+    start_event(ch,
+		5 SECONDS,
+		devent_on_complete, check_devent_involvement, 
+		ch, arg);
+  }
 }
 
 
diff -ruN ../nakedmudv2.4/src/exit.c src/exit.c
--- ../nakedmudv2.4/src/exit.c	Sat Jun  4 23:40:29 2005
+++ src/exit.c	Sat Jun 18 14:46:43 2005
@@ -27,11 +27,11 @@
   bitvector_t status;      // closable, closed, locked, etc...
 
   int closable;            // is the exit closable?
-  obj_vnum key;            // what is the vnum of the key?
+  int key;            // what is the vnum of the key?
   int hide_lev;            // how hidden is this exit?
   int pick_lev;            // how hard is it to pick this exit?
 
-  room_vnum to;            // where do we exit to?
+  int to;            // where do we exit to?
 };
 
 
@@ -149,11 +149,11 @@
   return exit->pick_lev;
 };
 
-obj_vnum    exitGetKey(const EXIT_DATA *exit) {
+int    exitGetKey(const EXIT_DATA *exit) {
   return exit->key;
 };
 
-room_vnum   exitGetTo(const EXIT_DATA *exit) {
+int   exitGetTo(const EXIT_DATA *exit) {
   return exit->to;
 };
 
@@ -195,7 +195,7 @@
   else          REMOVE_BIT(exit->status, EX_LOCKED);
 };
 
-void        exitSetKey(EXIT_DATA *exit, obj_vnum key) {
+void        exitSetKey(EXIT_DATA *exit, int key) {
   exit->key = key;
 };
 
@@ -207,7 +207,7 @@
   exit->pick_lev = pick_lev;
 };
 
-void        exitSetTo(EXIT_DATA *exit, room_vnum room) {
+void        exitSetTo(EXIT_DATA *exit, int room) {
   exit->to = room;
 };
 
diff -ruN ../nakedmudv2.4/src/exit.h src/exit.h
--- ../nakedmudv2.4/src/exit.h	Sat Jun  4 23:40:29 2005
+++ src/exit.h	Sat Jun 18 14:46:43 2005
@@ -58,8 +58,8 @@
 
 int         exitGetHidden      (const EXIT_DATA *exit);
 int         exitGetPickLev     (const EXIT_DATA *exit);
-obj_vnum    exitGetKey         (const EXIT_DATA *exit);
-room_vnum   exitGetTo          (const EXIT_DATA *exit);
+int    exitGetKey         (const EXIT_DATA *exit);
+int   exitGetTo          (const EXIT_DATA *exit);
 const char *exitGetName        (const EXIT_DATA *exit);
 const char *exitGetKeywords    (const EXIT_DATA *exit);
 const char *exitGetDesc        (const EXIT_DATA *exit);
@@ -70,10 +70,10 @@
 void        exitSetClosable    (EXIT_DATA *exit, bool closable);
 void        exitSetClosed      (EXIT_DATA *exit, bool closed);
 void        exitSetLocked      (EXIT_DATA *exit, bool locked);
-void        exitSetKey         (EXIT_DATA *exit, obj_vnum key);
+void        exitSetKey         (EXIT_DATA *exit, int key);
 void        exitSetHidden      (EXIT_DATA *exit, int hide_lev);
 void        exitSetPickLev     (EXIT_DATA *exit, int pick_lev);
-void        exitSetTo          (EXIT_DATA *exit, room_vnum room);
+void        exitSetTo          (EXIT_DATA *exit, int room);
 void        exitSetName        (EXIT_DATA *exit, const char *name);
 void        exitSetKeywords    (EXIT_DATA *exit, const char *keywords);
 void        exitSetDesc        (EXIT_DATA *exit, const char *desc);
diff -ruN ../nakedmudv2.4/src/handler.c src/handler.c
--- ../nakedmudv2.4/src/handler.c	Sat Jun  4 23:40:29 2005
+++ src/handler.c	Sat Jun 18 14:46:43 2005
@@ -245,6 +245,8 @@
 
 void do_drop(CHAR_DATA *ch, OBJ_DATA *obj) {
   send_to_char(ch, "You drop %s.\r\n", objGetName(obj));
+  message(ch, NULL, obj, NULL, TRUE, TO_ROOM,
+	  "$n drops $o.");
   obj_from_char(obj);
   obj_to_room(obj, charGetRoom(ch));
 
@@ -259,7 +261,7 @@
 
 
 void do_wear(CHAR_DATA *ch, OBJ_DATA *obj, const char *where) {
-  if(objIsType(obj, "worn"))
+  if(!objIsType(obj, "worn"))
     send_to_char(ch, "You cannot wear %s!\r\n", objGetName(obj));
   else {
     obj_from_char(obj);
diff -ruN ../nakedmudv2.4/src/hashtable.h src/hashtable.h
--- ../nakedmudv2.4/src/hashtable.h	Sat Jun  4 23:40:29 2005
+++ src/hashtable.h	Sat Jun 18 14:46:43 2005
@@ -40,6 +40,19 @@
 // must be deleted after use. Try: deleteListWith(list, free)
 LIST *hashCollect(HASHTABLE *table);
 
+
+
+//*****************************************************************************
+// prototypes for the hashtable iterator
+//*****************************************************************************
+
+// iterate across all the elements in a hashtable
+#define ITERATE_HASH(key, val, it) \
+  for(key = hashIteratorCurrentKey(it), val = hashIteratorCurrentVal(it); \
+      key != NULL; \
+      hashIteratorNext(it), \
+      key = hashIteratorCurrentKey(it), val = hashIteratorCurrentVal(it))
+
 HASH_ITERATOR *newHashIterator     (HASHTABLE *table);
 void        deleteHashIterator     (HASH_ITERATOR *I);
 
diff -ruN ../nakedmudv2.4/src/inform.c src/inform.c
--- ../nakedmudv2.4/src/inform.c	Sat Jun  4 23:40:29 2005
+++ src/inform.c	Sat Jun 18 14:46:43 2005
@@ -726,12 +726,12 @@
 	break;
       case 's':
 	if(!ch) break;
-	sprintf(buf+j, (can_see_char(to, ch) ? HISHERS(ch) :SOMEONE"'s"));
+	sprintf(buf+j, (can_see_char(to, ch) ? HISHER(ch) :SOMEONE"'s"));
 	while(buf[j] != '\0') j++;
 	break;
       case 'S':
 	if(!vict) break;
-	sprintf(buf+j, (can_see_char(to, vict) ? HISHERS(vict) :SOMEONE"'s"));
+	sprintf(buf+j, (can_see_char(to, vict) ? HISHER(vict) :SOMEONE"'s"));
 	while(buf[j] != '\0') j++;
 	break;
       case 'e':
diff -ruN ../nakedmudv2.4/src/interpret.c src/interpret.c
--- ../nakedmudv2.4/src/interpret.c	Sat Jun  4 23:40:29 2005
+++ src/interpret.c	Sat Jun 18 14:46:43 2005
@@ -97,6 +97,8 @@
 	  "player", TRUE, FALSE);
   add_cmd("at",         NULL, cmd_at,       0, POS_UNCONCIOUS, POS_FLYING,
 	  "builder", TRUE, FALSE);
+  add_cmd("attach",     NULL, cmd_attach,   0, POS_UNCONCIOUS, POS_FLYING,
+	  "scripter", FALSE, FALSE);
 
   // B
   add_cmd("back",       NULL, cmd_back,     0, POS_UNCONCIOUS, POS_FLYING,
@@ -129,6 +131,8 @@
 	  "builder", FALSE, FALSE);
   add_cmd("drop",       NULL, cmd_drop,     0, POS_SITTING,  POS_FLYING,
 	  "player", TRUE, TRUE );
+  add_cmd("detach",     NULL, cmd_detach,   0, POS_UNCONCIOUS, POS_FLYING,
+	  "scripter", FALSE, FALSE);
 
   // E
   add_cmd("emote",      NULL, cmd_emote,    0, POS_SITTING,  POS_FLYING,
diff -ruN ../nakedmudv2.4/src/items/portal.c src/items/portal.c
--- ../nakedmudv2.4/src/items/portal.c	Sat Jun  4 23:40:29 2005
+++ src/items/portal.c	Sat Jun 18 14:46:43 2005
@@ -97,8 +97,10 @@
 
 
     // we're trying to enter an exit
-    if(found && found_type == FOUND_EXIT)
-      try_exit(ch, found, DIR_NONE);
+    if(found && found_type == FOUND_EXIT) {
+      ROOM_DATA *to = try_exit(ch, found, DIR_NONE);
+      if(to != NULL) look_at_room(ch, to);
+    }
 
     // we're trying to enter a portal
     else if(found && found_type == FOUND_OBJ) {
diff -ruN ../nakedmudv2.4/src/list.h src/list.h
--- ../nakedmudv2.4/src/list.h	Sat Jun  4 23:40:30 2005
+++ src/list.h	Sat Jun 18 14:46:43 2005
@@ -148,6 +148,15 @@
 LIST *listCopyWith(LIST *L, void *func);
 
 
+
+//*****************************************************************************
+// list iterator function prototypes
+//*****************************************************************************
+
+// iterate across all the elements in a list
+#define ITERATE_LIST(val, it) \
+  for(val = listIteratorCurrent(it); val != NULL; val = listIteratorNext(it))
+
 //
 // Create an iterator to go over the list
 //
diff -ruN ../nakedmudv2.4/src/map.h src/map.h
--- ../nakedmudv2.4/src/map.h	Sat Jun  4 23:40:30 2005
+++ src/map.h	Sat Jun 18 14:46:43 2005
@@ -31,6 +31,18 @@
 int   mapIn     (MAP *map, const void *key);
 int   mapSize   (MAP *map);
 
+
+//*****************************************************************************
+// map iterator function prototypes
+//*****************************************************************************
+
+// iterate across all of the elements in a map
+#define ITERATE_MAP(key, val, it) \
+  for(key = mapIteratorCurrentKey(it), val = mapIteratorCurrentVal(it); \
+      key != NULL; \
+      mapIteratorNext(it), \
+      key = mapIteratorCurrentKey(it), val = mapIteratorCurrentVal(it))
+
 MAP_ITERATOR *newMapIterator(MAP *map);
 void          deleteMapIterator(MAP_ITERATOR *I);
 
diff -ruN ../nakedmudv2.4/src/movement.c src/movement.c
--- ../nakedmudv2.4/src/movement.c	Sat Jun  4 23:40:30 2005
+++ src/movement.c	Sat Jun 18 14:46:43 2005
@@ -29,7 +29,7 @@
 
 
 
-bool try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir) {
+ROOM_DATA *try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir) {
   ROOM_DATA *to   = NULL;
 
   if(exitIsClosed(exit))
@@ -49,7 +49,6 @@
 
     char_from_room(ch);
     char_to_room(ch, to);
-    look_at_room(ch, to);
 
     if(*exitGetSpecEnter(exit))
       message(ch, NULL, NULL, NULL, FALSE, TO_ROOM, exitGetSpecEnter(exit));
@@ -59,9 +58,9 @@
     else
       send_around_char(ch, TRUE, "%s has arrived.\r\n", charGetName(ch));
 
-    return TRUE;
+    return to;
   }
-  return FALSE;
+  return NULL;
 }
 
 
@@ -77,7 +76,7 @@
     log_string("ERROR: %s tried to buildwalk %s, but room %d was not in a zone!", charGetName(ch), dirGetName(dir), roomGetVnum(charGetRoom(ch)));
   }
   else {
-    room_vnum vnum = getFreeRoomVnum(zone);
+    int vnum = getFreeRoomVnum(zone);
     if(vnum == NOWHERE)
       send_to_char(ch, 
 		   "Zone #%d has no free rooms left. "
@@ -125,14 +124,19 @@
 
   else {
     ROOM_DATA *old_room = charGetRoom(ch);
-    bool success = try_exit(ch, exit, dir);
-    if(success) {
+    ROOM_DATA *new_room = try_exit(ch, exit, dir);
+    if(new_room) {
+      // move ourself back for a second so we can do the exit script...
+      char_to_room(ch, old_room);
       try_exit_script(ch, old_room, 
 		      (dir != DIR_NONE ? dirGetName(dir) : specdir));
+      char_to_room(ch, new_room);
+
       try_enterance_script(ch, charGetRoom(ch),
 			   (dir != DIR_NONE ? dirGetName(dir) : specdir));
+      look_at_room(ch, new_room);
     }
-    return success;
+    return (new_room != NULL);
   }
 }
 
diff -ruN ../nakedmudv2.4/src/movement.h src/movement.h
--- ../nakedmudv2.4/src/movement.h	Sat Jun  4 23:40:30 2005
+++ src/movement.h	Sat Jun 18 14:46:43 2005
@@ -24,9 +24,9 @@
 //
 // Go through an exit. use dir for display purposes to the room
 // (e.g. bob leaves north). If dir == DIR_NONE, no direction info
-// is said
+// is said. Return the new room we are in, if we moved
 //
-bool try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir);
+ROOM_DATA *try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir);
 
 //
 // Try creating a new room in the specified direction, drawn from the
diff -ruN ../nakedmudv2.4/src/mud.h src/mud.h
--- ../nakedmudv2.4/src/mud.h	Sat Jun  4 23:40:30 2005
+++ src/mud.h	Sat Jun 18 15:33:28 2005
@@ -65,13 +65,6 @@
 typedef struct body_data                  BODY_DATA;
 typedef struct reset_data                 RESET_DATA;
 
-typedef int                               shop_vnum;
-typedef int                               room_vnum;
-typedef int                               zone_vnum;
-typedef int                               mob_vnum;
-typedef int                               obj_vnum;
-typedef int                               script_vnum;
-typedef int                               dialog_vnum;
 typedef long                              bitvector_t;
 
 // define simple types
diff -ruN ../nakedmudv2.4/src/object.c src/object.c
--- ../nakedmudv2.4/src/object.c	Sat Jun  4 23:40:30 2005
+++ src/object.c	Sat Jun 18 14:46:43 2005
@@ -27,7 +27,7 @@
 
 
 struct object_data {
-  obj_vnum vnum;                 // our number for builders
+  int vnum;                 // our number for builders
   int      uid;                  // our unique identifier
   double   weight;               // how much do we weigh, minus contents
   
@@ -196,7 +196,7 @@
   return obj->users;
 }
 
-obj_vnum objGetVnum(OBJ_DATA *obj) {
+int objGetVnum(OBJ_DATA *obj) {
   return obj->vnum;
 }
 
@@ -283,7 +283,7 @@
   return hashGet(obj->auxiliary_data, name);
 }
 
-void objSetVnum(OBJ_DATA *obj, obj_vnum vnum) {
+void objSetVnum(OBJ_DATA *obj, int vnum) {
   obj->vnum = vnum;
 }
 
diff -ruN ../nakedmudv2.4/src/object.h src/object.h
--- ../nakedmudv2.4/src/object.h	Sat Jun  4 23:40:30 2005
+++ src/object.h	Sat Jun 18 14:46:43 2005
@@ -34,7 +34,7 @@
 // set and get functions
 //
 //*****************************************************************************
-obj_vnum     objGetVnum      (OBJ_DATA *obj);
+int     objGetVnum      (OBJ_DATA *obj);
 const char  *objGetName      (OBJ_DATA *obj);
 const char  *objGetKeywords  (OBJ_DATA *obj);
 const char  *objGetRdesc     (OBJ_DATA *obj);
@@ -56,7 +56,7 @@
 void        *objGetAuxiliaryData(const OBJ_DATA *obj, const char *name);
 BITVECTOR   *objGetBits      (OBJ_DATA *obj);
 
-void         objSetVnum      (OBJ_DATA *obj, obj_vnum vnum);
+void         objSetVnum      (OBJ_DATA *obj, int vnum);
 void         objSetName      (OBJ_DATA *obj, const char *name);
 void         objSetKeywords  (OBJ_DATA *obj, const char *keywords);
 void         objSetRdesc     (OBJ_DATA *obj, const char *rdesc);
diff -ruN ../nakedmudv2.4/src/olc2/medit.c src/olc2/medit.c
--- ../nakedmudv2.4/src/olc2/medit.c	Sat Jun  4 23:40:29 2005
+++ src/olc2/medit.c	Sat Jun 18 14:46:43 2005
@@ -179,7 +179,7 @@
   // we're editing a mobile by vnum... edit the prototype
   else {
     ZONE_DATA *zone = NULL;
-    mob_vnum vnum   = atoi(arg);
+    int vnum   = atoi(arg);
 
     // make sure there is a corresponding zone ...
     if((zone = worldZoneBounding(gameworld, vnum)) == NULL)
diff -ruN ../nakedmudv2.4/src/olc2/oedit.c src/olc2/oedit.c
--- ../nakedmudv2.4/src/olc2/oedit.c	Sat Jun  4 23:40:29 2005
+++ src/olc2/oedit.c	Sat Jun 18 14:46:43 2005
@@ -168,7 +168,7 @@
   // we're editing an object by vnum... edit the prototype
   else {
     ZONE_DATA *zone = NULL;
-    obj_vnum   vnum = atoi(arg);
+    int   vnum = atoi(arg);
 
     // make sure there is a corresponding zone ...
     if((zone = worldZoneBounding(gameworld, vnum)) == NULL)
